<?php
function xml_cdata_callback($data){
	return htmlspecialchars($data[1]);
}

function getXML($file){
	$xml = join('',file($file));
	$xml = preg_replace_callback("/<!\[CDATA\[(.*?)\]\]>/sm","xml_cdata_callback",$xml);
	$dom = new domDocument('1.0','UTF-8');
	$dom->preserveWhiteSpace = false;
	$dom->resolveExternals   = false;
	$dom->validateOnParse    = false;
	if(!$dom->loadXML($xml))error("Invalid XML file.<br>");
	$rootNodeName = $dom->documentElement->nodeName;
	$imp = new DOMImplementation;
	$dtd = $imp->createDocumentType(
		$rootNodeName,'',
		$GLOBALS['cfg']['l2jzHomeDir'].'/engine/dtd/'.$rootNodeName.'.dtd'
	);
	$domWithDtd = $imp->createDocument("","",$dtd);
	$domWithDtd->encoding = 'UTF-8';
	$domWithDtd->version  = '1.0';
	$domWithDtdRoot = $domWithDtd->importNode($dom->documentElement,true);
	$domWithDtd->appendChild($domWithDtdRoot);
	$domWithDtd->validate();
	return $domWithDtd->documentElement;
}

function getSectionAttr($node,$row=array()){
	$addToQueryLink = TRUE;
	for($j=0;$j<$node->attributes->length;$j++){
		$name  = $node->attributes->item($j)->nodeName;
		$value = $node->attributes->item($j)->nodeValue;
		switch($name){
			case"name":
				if(isset($row['name'])){
					$row['name'] = $row['name'].".".$value;
				} else {
					$row['name'] = $value;
				}
			break;
			default:
				$row[$name] = $value;
		}
	}
	return $row;
}

function getAttr($node,$row=array()){
	for($j=0;$j<$node->attributes->length;$j++){
		$name  = $node->attributes->item($j)->nodeName;
		$value = $node->attributes->item($j)->nodeValue;
		$row[$name] = $value;
	}
	return $row;
}

function ArrayToPhpFile($array_name,$array,$file){
	ob_start();
	var_export($array);
	$php_code = ob_get_contents();
	ob_end_clean();
	$php_code = preg_replace("/'\s*=>\s*array\s*\(/m","'=>array(",$php_code);
	$php_code = preg_replace("/'(\d*)'/m","$1",$php_code);
	$php_code = "<?php\n//This file was automaticaly generated by L2JZ engine.\n\$".$array_name." = ".$php_code.";\n?>";
	$fp = fopen($file,"w");
	fwrite($fp,$php_code);
	fclose($fp);
}

function ArrayToJsFile($array_name,$array,$file){
	$js_code = php2js($array);
	$js_code = "//This file was automaticaly generated by L2JZ engine.\nvar ".$array_name." = \n".$js_code.";";
	$fp = fopen($file,"w");
	fwrite($fp,$js_code);
	fclose($fp);
}

function php2js($a){
	if (is_null($a)) return 'null';
	if ($a === false) return 'false';
	if ($a === true) return 'true';
	if (is_scalar($a)) {
		$a = addslashes($a);
		$a = str_replace("\n", '\n', $a);
		$a = str_replace("\r", '\r', $a);
		return "'$a'";
	}
	$isList = true;
	for ($i=0, reset($a); $i<count($a); $i++, next($a))if(key($a)!==$i){
		$isList = false;
		break;
	}
	$result = array();
	if ($isList) {
		foreach ($a as $v) $result[] = php2js($v);
		return "[".join(",", $result)."]";
	} else {
		foreach ($a as $k=>$v) $result[] = php2js($k).': '.php2js($v);
		return "{".join(",", $result)."}";
	}
}
?>