<?php
if(!defined('L2JZ'))exit;
ob_start();
require "engine/php/compileXML/convert_xml_lib.php";
require "engine/php/compileXML/convert_query.php";
require "engine/php/compileXML/convert_frame.php";
require "engine/php/compileXML/convert_pages.php";
require "engine/php/compileXML/convert_panels.php";
require "engine/php/compileXML/convert_tables.php";
require "engine/php/compileXML/jsCodeToTasks.php";
require "engine/php/compileXML/convert_language.php";
require "engine/php/compileXML/scanModuleForLocalObjects.php";
require "engine/php/compileXML/scanModuleForGlobalObjects.php";

//0 - Critical error. Do not save compile settings.
//1 - Warning. Data will be saved.
//2 - Just advice.
//3 - All is fine
function compileError($text,$level=1){
	switch($level){
		case"0":
			print '<font color="red">&nbsp;&nbsp;Error: </font>'.$text.'<br>';
		break;
		case"1":
			print '<font color="#996600">&nbsp;&nbsp;Warning: </font>'.$text.'<br>';
		break;
		case"2":
			print $text.'<br>';
		break;
	}
	if($GLOBALS['allIsFine']>$level)$GLOBALS['allIsFine'] = $level;
}
$allIsFine     = 3;
$l2jzVersionId = substr(md5((rand(1000000,9999999).microtime())),0,15);

//     
$modulesDir = opendir($GLOBALS['cfg']['l2jzHomeDir']."/modules");
while($file=readdir($modulesDir)){
	if(preg_match("/^\..*$/",$file))continue;
	$file = str_replace("/","",$file);
	$l2jzModules[$file] = $file;
}

//        .
$l2jz           = array();//     
$l2jzJS         = array();//     
$frames         = array();//    
$pagesTree      = array();//    
$modules        = array();//   
$hLanguage      = array();//    
$configArray    = array('l2jzVersionId'=>$l2jzVersionId);//    engine/php/option.php
foreach($l2jzModules as $moduleName)if(file_exists($GLOBALS['cfg']['l2jzHomeDir']."/modules/".$moduleName."/pages.xml")){
	scanModuleForGlobalObjects(
		$GLOBALS['cfg']['l2jzHomeDir']."/modules/".$moduleName,
		$moduleName,
		$moduleName
	);
}

print "Local objects<br>";
print "<div class='L2JZmodulesTree'>";
foreach($l2jzModules as $moduleName)if(file_exists($GLOBALS['cfg']['l2jzHomeDir']."/modules/".$moduleName."/pages.xml")){
	print "<div class='module'>".$moduleName."</div><div class='container'>";
	scanModuleForLocalObjects(
		$GLOBALS['cfg']['l2jzHomeDir']."/modules/".$moduleName,
		$moduleName,
		$moduleName
	);
	print "</div><br>";
}
print "</div>";

//    .
ArrayToPhpFile("l2jz",$l2jz,$GLOBALS['cfg']['l2jzHomeDir']."/engine/php/query_tree.php");

//  
foreach($modules as $moduleName=>$module){
	$code =  "//This file was automaticaly generated by L2JZ engine.\n";
	foreach($module as $col=>$data)switch($col){
		case"templates":
			foreach($data as $templateName=>$templateCode){
				$code .= "l2jz_tpl['".$templateName."'] = ".php2js($templateCode).";\n";
			}
		break;
		case "panels":
			foreach($data as $panelName=>$panel){
				$code .= "l2jz_pnl['".$panelName."'] = ".php2js($panel).";\n";
			}
		break;
		case"tables":
			foreach($data as $tableName=>$table){
				$code .= "l2jz_tbl['".$tableName."'] = ".php2js($table).";\n";
			}
		break;
	}
	if(isset($module['js']))$code .= $module['js'];
	$fp = fopen($GLOBALS['cfg']['l2jzHomeDir']."/engine/js/modules/".$moduleName.".js","w");
	fwrite($fp,$code);
	fclose($fp);
}

//  
print "Languages:<br>";
$languagesArray = array();
$baseLanguage   = $preloadedArray['baseLanguage'] = $cfg['baseLanguage'];
$hLanguageBASE  = $hLanguage[$baseLanguage];
foreach($hLanguage as $language=>$data){
	$configArray['languages'][] = $language;
	$languagesArray[$language] = $language;
}
unset($languagesArray[$baseLanguage]);
foreach($languagesArray as $language){
	foreach($hLanguageBASE as $name=>$value){
		if(!isset($hLanguage[$language][$name]))$hLanguage[$language][$name] = $value;
	}
}
foreach($hLanguage as $language=>$data){
	print "&nbsp;&nbsp;$language".(($language==$baseLanguage)?"[BASE]":"")."<br>";
	$code = "l2jz_h={";
	foreach($data as $name=>$value){
		$code .= "'".$name."':".php2js($value).",\n";
	}
	$code .= "'_':''}";
	$fp = fopen($GLOBALS['cfg']['l2jzHomeDir']."/engine/js/language/".$language.".js","w");
	fwrite($fp,$code);
	fclose($fp);
}

//      .
$preloadedCode  = "//This file was automaticaly generated by L2JZ engine.\n";

//  .
$preloadedCode .= "l2jz_q_t=".php2js($l2jzJS).";";

//  .
$preloadedCode .= "l2jz_p_t=".php2js($pagesTree).";";

// .
$preloadedCode .= "l2jz_frames=".php2js($frames).";";

//  .
$fp = fopen($GLOBALS['cfg']['l2jzHomeDir']."/engine/js/preloadedData.js","w");
fwrite($fp,$preloadedCode);
fclose($fp);

// PHP  .
ArrayToPhpFile("config",$configArray,$GLOBALS['cfg']['l2jzHomeDir']."/engine/php/config.php");

$_RESULT = ob_get_contents();
ob_end_clean();
switch($allIsFine){
	case"0":
		print "Compilation failed.";
	break;
	case"1":
		print "The system was compiled with warnings.";
	break;
	case"2":case"3":
		print "The system was successful compiled.";
	break;
}
?>